:: signal status monitoring
:: hw-api example
:: usage: z-status [<0|1>] -- 0 - update info w/o delay, 1 - one sec delay

@echo off
setlocal
cls

echo Connecting to web-api...

call hw-api Init || goto ErrorExit
call hw-api Auth || goto ErrorExit

set _delay=0
if not "%~1"=="" (if not "%~1%"=="0" set _delay=1)

:Loop
call hw-api Get api/monitoring/status
call hw-api ValRoot /response
call :valParse ConnectionStatus _cs
call :valParse CurrentNetworkType _cnt

call hw-api Get operator.cgi
call hw-api Val "/response/FullName" _op

call hw-api Get /api/device/signal
call hw-api ValRoot "/response"
call hw-api Val "cell_id" _cell_id
call :valEsc "rssi" _rssi
call :valEsc "rsrp" _rsrp
call :valEsc "rsrq" _rsrq
call :valEsc "sinr" _sinr

call hw-api Get /config/deviceinformation/add_param.xml
call hw-api ValRoot "/config"
call hw-api Val "freq1" _freq1
call hw-api Val "freq2" _freq2

title %_op% (%_cnt%)

cls
echo Operator: %_op% (%_cnt%)
echo Cell ID: %_cell_id%
echo Freq: %_freq1% / %_freq2%
echo.
echo RSSI: %_rssi%
echo RSRP: %_rsrp%
echo SINR: %_sinr%
echo RSRQ: %_rsrq%
echo.
echo Status: %_cs%
echo.
echo.

if %_delay%==0 (
	echo ^< press CTRL-C to quit ^>
	goto Loop
)

echo ^< press Q to quit ^>
choice /C qn  /D n /T 1 >nul
if %errorlevel%==2 goto Loop
goto Exit

:ErrorExit
echo API %api_cmd% ERROR: #%api_error%

:Exit
echo.
echo Quit
echo.
call hw-api Done
endlocal
pause
exit /b

:valEsc
:: escape html &-codes
call hw-api Val %1 _
set "_=%_:&gt;=^>%"
set "_=%_:&lt;=^<%"
set "_=%_:&=%"
set "%2=%_%"
exit /b

:valParse
:: valParse <val> [<var>]
:: get value from response and parse it code (if _const_<val> exists)
:: result placed in variable _ and <var> (optional)
call hw-api Val %1 _
call :_const_%1 %_% > nul
if not "%~2"=="" set %~2=%_%
exit /b

:: consts
:_const_ConnectionStatus
if %1==900 set _=CONNECTING
if %1==901 set _=CONNECTED
if %1==902 set _=DISCONNECTED
if %1==903 set _=DISCONNECTING
exit /b

:_const_CurrentNetworkType
if %1==0 set _=no service
if %1==1 set _=GSM
if %1==2 set _=GPRS
if %1==3 set _=EDGE
if %1==4 set _=WCDMA
if %1==5 set _=HSDPA
if %1==6 set _=HSUPA
if %1==7 set _=HSPA
if %1==8 set _=TDSCDMA
if %1==9 set _=HSPA_PLUS
if %1==10 set _=EVDO_REV_0
if %1==11 set _=EVDO_REV_A
if %1==12 set _=EVDO_REV_B
if %1==13 set _=1xRTT
if %1==14 set _=UMB
if %1==15 set _=1xEVDV
if %1==16 set _=3xRTT
if %1==17 set _=HSPA_PLUS_64QAM
if %1==18 set _=HSPA_PLUS_MIMO
if %1==19 set _=LTE
exit /b
